{***********************************************}
{       Simple DEMO Program for using           }
{                                               }
{           Expression Parser                   }
{      for DELPHI 1.0, 3.0, 4.0 and 5.0         }
{                                               }
{           by Todor Marholev                   }
{       e-mail: spsoft@mail.vega.bg             }
{***********************************************}

unit Unit1;

interface

uses
  SysUtils, {$IFDEF WIN32}Windows,{$ELSE}WinProcs, WinTypes,{$ENDIF} Messages,
  Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExPars, Vars, ExLink,
  DBTables, DB, parstype, ExFuncs, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label2: TLabel;
    ResultLbl: TLabel;
    ExprParser1: TExParser;
    EPUserLib1: TEPUserLib;
    Button5: TButton;
    Button6: TButton;
    EPVars1: TEPVars;
    Table1: TTable;
    DataSource1: TDataSource;
    EPRegFuncs1: TEPRegFuncs;
    Memo1: TMemo;
    Button7: TButton;
    Button8: TButton;
    ResultLbl2: TLabel;
    Database1: TDatabase;
    DescrLbl: TLabel;
    Button9: TButton;
    EPRegFuncs1MYPROD1: TEPEventFunc;
    EPVars1VAR1: TVariable;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    function ExprParser1Variable(Sender: TObject;
      const VarName: String): Extended;
    function ExprParser1Function(Sender: TObject; const FuncName: String;
      const FuncParams: array of Extended): Extended;
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    function EPRegFuncs1MYPROD1Evaluate(
      const Params: array of Extended): Extended;
    function EPVars1VAR1CalcValue(Sender: TVariable): Extended;
  private
    { Private declarations }
  public
    { Public declarations }
    InitVal: Extended;
    procedure ShowResult(ALabel: TLabel; AValue: Extended);
  end;

var
  Form1: TForm1;

implementation

uses Unit2;
{$R *.DFM}

procedure _MySum(AnOper: PParserOperation); far;
var I : Integer;
begin
  with AnOper^ do
    For I:=1 to ArgCnt do
      case I of
        1: dest^:=arg1^;
        2: dest^:=dest^+arg2^;
        3: dest^:=dest^+arg3^;
       else dest^:=dest^+args^[I-1]^;
      end;
end;

function _MyAVG(Params: array of Extended): Extended; far;
var I : Integer;
begin
   Result:=0;
   if Integer(High(Params))>=0 then begin
     for I:=0 to Integer(High(Params)) do Result:=Result+Params[I];
     Result:=Result / (Integer(High(Params))+1);
   end;
end;

procedure TForm1.ShowResult(ALabel: TLabel; AValue: Extended);
begin
   if ALabel is TLabel then ALabel.Caption:=FloatToStr(AValue);
end;

function TForm1.EPRegFuncs1MYPROD1Evaluate(const Params: array of Extended): Extended;
var I: Integer;
begin
   if Integer(High(Params))>=0 then begin
     Result:=1;
     for I:=0 to Integer(High(Params)) do Result:=Result*Params[I];
   end else Result:=0;
end;

function TForm1.EPVars1VAR1CalcValue(Sender: TVariable): Extended;
begin
   Result:=40;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   InitVal:=10;
   EPRegFuncs1.AddFunction('MySum', _MySum, -1 {Unlimited number of arguments},'My SUM function',fct_Aggregate);
   EPRegFuncs1.AddStdFunction('MyAVG',@_MyAVG, [typeArray], typeExtended ,'My AVG function', fct_Custom);
   EPRegFuncs1.AddClassFunction('ShowResult',@TForm1.ShowResult, Self, [typeLongInt, typeExtended], typeVoid ,
                                'Outputs a value in a label''s caption', fct_Custom);
   Table1.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   ExprParser1.EditVariables;
  { EPVars1.EditVariables;}
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   EPUserLib1.Edit;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
   EPUserLib1.IniFile:='';
   {If a Path is not specified, INI file must be in the Windows directory}
   EPUserLib1.IniFile:='demolib.INI';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   ExprParser1.Expression.Assign(Memo1.Lines);
   ResultLbl.Caption:=FloatToStr(ExprParser1.F([3,2,4]));
end;

procedure TForm1.Button6Click(Sender: TObject);
var ADlg: TUsedVarsEditDlg;
begin
   ExprParser1.Expression.Assign(Memo1.Lines);
   ADlg:=TUsedVarsEditDlg.Create(Self);
   try
     with ADlg do begin
       AnExprParser:=Self.ExprParser1;
       ShowModal;
     end;
   finally ADlg.Free; end;
end;

function TForm1.ExprParser1Variable(Sender: TObject; const VarName: String): Extended;
var AnIdx: Integer;
begin
   Result:=0;
   If VarName=UpperCase('x2') then begin
     Result:=5;
   end else If VarName='Y2' then begin
     Result:=3;
   end else with ExprParser1.UsedVariables do
     If Find(VarName,AnIdx) then Result:=Value[AnIdx];
end;

function TForm1.ExprParser1Function(Sender: TObject;
  const FuncName: String; const FuncParams: array of Extended): Extended;
var I : Integer;
begin
   Result:=0;
   If FuncName=UpperCase('MyFunc') then begin
     Result:=FuncParams[0]*FuncParams[1]+FuncParams[2];
   end else
   If FuncName=UpperCase('MyFunc1') then begin
     Result:=SQR(FuncParams[0]) + FuncParams[1];
   end else
   If FuncName=UpperCase('MySumFunc') then begin
     For I:=0 to Integer(High(FuncParams)) do Result:=Result+FuncParams[I];
   end else raise Exception.Create('Unknown function name: '+FuncName);
end;

procedure TForm1.Button3Click(Sender: TObject);
procedure AddUserLibExpr(AList: TEPExprList; AName, AExpr: String);
var ASrc: TStrings;
    AIdx: Integer;
begin
   ASrc:=TStringList.Create;
   try
     ASrc.Add(AExpr);
     with AList do if Find(AName,AIdx) then Sources[AIdx]:=ASrc else Add(AName,ASrc);
   finally ASrc.Free; end;
end;
begin
   ResultLbl.Caption:='0'; ResultLbl2.Caption:='';
   EPVars1['x1'].Value:=4;
   EPVars1['y1'].Value:=3;
   AddUserLibExpr(EPUserLib1.Aliases,'x','%0');
   with EPUserLib1.Aliases do begin
     AddExpr('y','%1');
     AddExpr('z','%2');
   end;
   with EPUserLib1.UserFuncs do begin
     AddExpr('LibFunc1','x + y^3');
     AddExpr('LibFunc2','LibFunc1(x,y)^2');
   end;
   with Memo1.Lines do begin
     Clear;
     Add('x1 ^ y1 + MySum(MyFunc(x,y,z),MyFunc(x+4,y+1,z+9),');
     Add('prod(x2,y2),MyFunc1(x2,y2),LibFunc2(x2,y2),x3^y3)');
   end;
   DescrLbl.Caption:='A complex single line expression demo, that uses function arguments, user defined library'+
                     ' functions and aliases, variables and registered math procedure. '+
                     ' You can try to load other definitions for library functions from INI file.';
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
   ResultLbl.Caption:='0'; ResultLbl2.Caption:='';
   with Memo1.Lines do begin
     Clear;
     Add('ACount:=0;');
     Add('Result:=0;');
     Add('DFirst([Table1]);');
     Add('while Not(DEOF([Table1])) do begin');
     Add('   Result:=Result+[DataSource1].Value;');
     Add('   ACount:=ACount+1;');
     Add('   DNext([Table1]);');
     Add('   if Result>100 then break;');
     Add('end;');
     Add('ShowResult([ResultLbl2], ACount);');
   end;
   DescrLbl.Caption:='This demo shows using of runtime components, DB fields and functions,'+
                    ' while cycle, and registered class functions (ShowResult). You can use BREAK for break the cycle.';
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
   ResultLbl.Caption:='0'; ResultLbl2.Caption:='';
   with Memo1.Lines do begin
     Clear;
     Add('Sum:=0; K:=3;');
     Add('if k<5 then');
     Add('  for I:=0 to 30 do begin');
     Add('    if (I>=0) and (I<5) then Sum:=Sum+3');
     Add('    else if (I>=5) and (I<20) then Sum:=Sum+5');
     Add('    else if (I>=20) and (I<=30) then Sum:=Sum+10;');
     Add('  end');
     Add('else if k<10 then begin');
     Add('  I:=0;');
     Add('  repeat');
     Add('    if (I>=0) and (I<10) then Sum:=Sum+4');
     Add('    else if (I>=10) and (I<20) then Sum:=Sum+5');
     Add('    else if (I>=20) and (I<=30) then Sum:=Sum+6;');
     Add('    Inc(I);');
     Add('  until I>30;');
     Add('end else begin');
     Add('  I:=0;');
     Add('  while I<=30 do begin');
     Add('    Sum:=Sum+10;');
     Add('    Inc(I);');
     Add('  end;');
     Add('end;');
     Add('Result:=Sum;');
     Add('ShowResult([ResultLbl2],I);');
   end;
   DescrLbl.Caption:='This demo is a complex script that uses many nested ''if then else'' statements and cycles.';
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   ResultLbl.Caption:='0'; ResultLbl2.Caption:='';
   with EPVars1['RTVar'] do begin
     Descr:='A link to a runtime variable';
     LinkTo(@InitVal);
   end;
   with Memo1.Lines do begin
     Clear;
     Add('I:=MyPROD(RTVar,4,5);');
     Add('Result:=MySUM(3,Var1,5,MyAVG(2,3,4,5));');
     Add('ShowResult([ResultLbl2], I);');
   end;
   DescrLbl.Caption:='This is an example of using a runtime variables and registered functions, and ''on event'' '+
                     'evaluated variables and registered functions.';
end;

end.
